<?php
/*
Plugin Name: Atomic WhatsApp Extractor
Description: A plugin to extract WhatsApp numbers using Google Places API.
Version: 1.0
Author: Votre Nom
*/

// Add menu items
add_action('admin_menu', 'awe_add_menu');
function awe_add_menu() {
    add_menu_page('Atomic WhatsApp Extractor', 'Atomic WhatsApp Extractor', 'manage_options', 'awe-main-menu', 'awe_main_page');
    add_submenu_page('awe-main-menu', 'Settings', 'Settings', 'manage_options', 'awe-settings', 'awe_settings_page');
    add_submenu_page('awe-main-menu', 'Extract Number', 'Extract Number', 'manage_options', 'awe-extract', 'awe_extract_page');
}

// Main page callback
function awe_main_page() {
    awsAction();
    echo '<h1>Atomic WhatsApp Extractor</h1>';
    echo '<p>Welcome to the Atomic WhatsApp Extractor plugin!</p>';
}

// Settings page callback
function awe_settings_page() {
     $order_paid=get_option('aws_p');
    if(!$order_paid)
    return;
    ?>
    <div class="wrap">
        <h1>Settings</h1>
        <form method="post" action="options.php">
            <?php
            settings_fields('awe-settings-group');
            do_settings_sections('awe-settings-group');
            ?>
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">Google Places API Key</th>
                    <td><input type="text" name="awe_api_key" value="<?php echo esc_attr(get_option('awe_api_key')); ?>" /></td>
                </tr>
               
            </table>
            <?php submit_button(); ?>
        </form>
    </div>
    <?php
}

// Extract number page callback
function awe_extract_page() {
     $order_paid=get_option('aws_p');
    if(!$order_paid)
    return;
    $countries = [
        'Afghanistan' => '+93',
        'Albania' => '+355',
        'Algeria' => '+213',
        'Andorra' => '+376',
        'Angola' => '+244',
        'Antigua and Barbuda' => '+1-268',
        'Argentina' => '+54',
        'Armenia' => '+374',
        'Australia' => '+61',
        'Austria' => '+43',
        'Azerbaijan' => '+994',
        'Bahamas' => '+1-242',
        'Bahrain' => '+973',
        'Bangladesh' => '+880',
        'Barbados' => '+1-246',
        'Belarus' => '+375',
        'Belgium' => '+32',
        'Belize' => '+501',
        'Benin' => '+229',
        'Bhutan' => '+975',
        'Bolivia' => '+591',
        'Bosnia and Herzegovina' => '+387',
        'Botswana' => '+267',
        'Brazil' => '+55',
        'Brunei Darussalam' => '+673',
        'Bulgaria' => '+359',
        'Burkina Faso' => '+226',
        'Burundi' => '+257',
        'Cabo Verde' => '+238',
        'Cambodia' => '+855',
        'Cameroon' => '+237',
        'Canada' => '+1',
        'Central African Republic' => '+236',
        'Chad' => '+235',
        'Chile' => '+56',
        'China' => '+86',
        'Colombia' => '+57',
        'Comoros' => '+269',
        'Congo (Republic of the)' => '+242',
        'Costa Rica' => '+506',
        'Croatia' => '+385',
        'Cuba' => '+53',
        'Cyprus' => '+357',
        'Czech Republic' => '+420',
        'Democratic Republic of the Congo' => '+243',
        'Denmark' => '+45',
        'Djibouti' => '+253',
        'Dominica' => '+1-767',
        'Dominican Republic' => '+1-809, +1-829, +1-849',
        'Ecuador' => '+593',
        'Egypt' => '+20',
        'El Salvador' => '+503',
        'Equatorial Guinea' => '+240',
        'Eritrea' => '+291',
        'Estonia' => '+372',
        'Eswatini' => '+268',
        'Ethiopia' => '+251',
        'Fiji' => '+679',
        'Finland' => '+358',
        'France' => '+33',
        'Gabon' => '+241',
        'Gambia' => '+220',
        'Georgia' => '+995',
        'Germany' => '+49',
        'Ghana' => '+233',
        'Greece' => '+30',
        'Grenada' => '+1-473',
        'Guatemala' => '+502',
        'Guinea' => '+224',
        'Guinea-Bissau' => '+245',
        'Guyana' => '+592',
        'Haiti' => '+509',
        'Honduras' => '+504',
        'Hungary' => '+36',
        'Iceland' => '+354',
        'India' => '+91',
        'Indonesia' => '+62',
        'Iran' => '+98',
        'Iraq' => '+964',
        'Ireland' => '+353',
        'Israel' => '+972',
        'Italy' => '+39',
        'Jamaica' => '+1-876',
        'Japan' => '+81',
        'Jordan' => '+962',
        'Kazakhstan' => '+7',
        'Kenya' => '+254',
        'Kiribati' => '+686',
        'Korea, Democratic People\'s Republic of (North Korea)' => '+850',
        'Korea, Republic of (South Korea)' => '+82',
        'Kuwait' => '+965',
        'Kyrgyzstan' => '+996',
        'Lao People\'s Democratic Republic (Laos)' => '+856',
        'Latvia' => '+371',
        'Lebanon' => '+961',
        'Lesotho' => '+266',
        'Liberia' => '+231',
        'Libya' => '+218',
        'Liechtenstein' => '+423',
        'Lithuania' => '+370',
        'Luxembourg' => '+352',
        'Madagascar' => '+261',
        'Malawi' => '+265',
        'Malaysia' => '+60',
        'Maldives' => '+960',
        'Mali' => '+223',
        'Malta' => '+356',
        'Marshall Islands' => '+692',
        'Mauritania' => '+222',
        'Mauritius' => '+230',
        'Mexico' => '+52',
        'Micronesia (Federated States of)' => '+691',
        'Moldova' => '+373',
        'Monaco' => '+377',
        'Mongolia' => '+976',
        'Montenegro' => '+382',
        'Morocco' => '+212',
        'Mozambique' => '+258',
        'Myanmar' => '+95',
        'Namibia' => '+264',
        'Nauru' => '+674',
        'Nepal' => '+977',
        'Netherlands' => '+31',
        'New Zealand' => '+64',
        'Nicaragua' => '+505',
        'Niger' => '+227',
        'Nigeria' => '+234',
        'North Macedonia' => '+389',
        'Norway' => '+47',
        'Oman' => '+968',
        'Pakistan' => '+92',
        'Palau' => '+680',
        'Palestine' => '+970',
        'Panama' => '+507',
        'Papua New Guinea' => '+675',
        'Paraguay' => '+595',
        'Peru' => '+51',
        'Philippines' => '+63',
        'Poland' => '+48',
        'Portugal' => '+351',
        'Qatar' => '+974',
        'Romania' => '+40',
        'Russia' => '+7',
        'Rwanda' => '+250',
        'Saint Kitts and Nevis' => '+1-869',
        'Saint Lucia' => '+1-758',
        'Saint Vincent and the Grenadines' => '+1-784',
        'Samoa' => '+685',
        'San Marino' => '+378',
        'Sao Tome and Principe' => '+239',
        'Saudi Arabia' => '+966',
        'Senegal' => '+221',
        'Serbia' => '+381',
        'Seychelles' => '+248',
        'Sierra Leone' => '+232',
        'Singapore' => '+65',
        'Slovakia' => '+421',
        'Slovenia' => '+386',
        'Solomon Islands' => '+677',
        'Somalia' => '+252',
        'South Africa' => '+27',
        'South Sudan' => '+211',
        'Spain' => '+34',
        'Sri Lanka' => '+94',
        'Sudan' => '+249',
        'Suriname' => '+597',
        'Sweden' => '+46',
        'Switzerland' => '+41',
        'Syrian Arab Republic' => '+963',
        'Tajikistan' => '+992',
        'Tanzania' => '+255',
        'Thailand' => '+66',
        'Timor-Leste' => '+670',
        'Togo' => '+228',
        'Tonga' => '+676',
        'Trinidad and Tobago' => '+1-868',
        'Tunisia' => '+216',
        'Turkey' => '+90',
        'Turkmenistan' => '+993',
        'Tuvalu' => '+688',
        // Suite du tableau des pays avec leurs codes téléphoniques
        'Uganda' => '+256',
        'Ukraine' => '+380',
        'United Arab Emirates' => '+971',
        'United Kingdom' => '+44',
        'United States of America' => '+1',
        'Uruguay' => '+598',
        'Uzbekistan' => '+998',
        'Vanuatu' => '+678',
        'Vatican City State (Holy See)' => '+379',
        'Venezuela' => '+58',
        'Vietnam' => '+84',
        'Yemen' => '+967',
        'Zambia' => '+260',
        'Zimbabwe' => '+263'
    ];
    $import_numbers_url = admin_url('admin.php?page=aws_import_numbers');
    ?>
    <div class="wrap">
        <h1>Extract Numbers</h1>
        <form method="post" action="">
            <?php
           
            
                    if (isset($_POST['awe_location'])) {
            update_option('awe_location', sanitize_text_field($_POST['awe_location']));
        }

        // Mettre à jour awe_type avec le nom du pays
        if (isset($_POST['awe_type'])) {
            update_option('awe_type', sanitize_text_field($_POST['awe_type']));
        }
 if (isset($_POST['awe_regex'])) {
            update_option('awe_regex', sanitize_text_field($_POST['awe_regex']));
        }
        // Mettre à jour awe_country_code
        if (isset($_POST['country_code'])) {
            update_option('awe_country_code', sanitize_text_field($_POST['country_code']));
        }
 if (isset($_POST['awe_extract_numbers'])) {
                awe_extract_numbers();
            }
            ?>
            <style>
    .awe-wide-input {
        width: 100%;
        max-width: 400px;
        padding: 8px;
        margin-top: 5px;
        margin-bottom: 20px;
    }
</style>

            <p>
                <label for="selected-location">Selected Location (latitude,longitude):</label><br />
                <input type="text" id="selected-location" name="awe_location" value="<?php echo esc_attr(get_option('awe_location')); ?>" />
                 
                   <label for="selected-location">select the Type:</label><br /> 
                <input type="text" name="awe_type" value="<?php echo esc_attr(get_option('awe_type')); ?>" />
            <label for="selected-location">le numero commence par:</label><br /> 
                <input type="text" name="awe_regex" value="<?php echo esc_attr(get_option('awe_regex')); ?>" />
                  <h2>Select Country Code</h2>
          <select id="country-code" name="country_code" style="width: 100%;" class="awe-wide-input">
                    <?php
                    foreach ($countries as $country => $code) {
                        $selected = (get_option('awe_country_code') == $code) ? 'selected="selected"' : '';
                        echo '<option value="' . esc_attr($code) . '" data-id="' . esc_attr($country) . '" ' . $selected . '>' . esc_html($country) . ' (' . esc_html($code) . ')</option>';
                    }
                    ?>
                </select>
            </p>
            <input type="submit" name="awe_extract_numbers" value="Extract Numbers" class="button button-primary" />
              <a href="<?php echo esc_url($import_numbers_url); ?>" class="button button-secondary">Connect to WAS</a>
        
        </form>
        <div id="map" style="height: 400px; width: 100%; margin-top: 20px;"></div>
    </div>
<script>
        var map;
        var marker;

        function initMap() {
            map = new google.maps.Map(document.getElementById('map'), {
                center: {lat: 48.8566, lng: 2.3522}, // Default to Paris
                zoom: 3 // Zoom initial plus large pour afficher le monde
            });

            // Fonction pour centrer la carte sur un pays spécifique en utilisant le code téléphonique
            function centerMapOnCountry(countryCode) {
                var geocoder = new google.maps.Geocoder();
                var countryName = countryCodeToName(countryCode);
                geocoder.geocode({ 'address': countryName }, function(results, status) {
                    if (status == google.maps.GeocoderStatus.OK && results.length > 0) {
                        map.setCenter(results[0].geometry.location);
                        map.setZoom(7); // Zoomer pour le pays sélectionné (ajustez selon les besoins)
                        updateLocationField(results[0].geometry.location.lat(), results[0].geometry.location.lng());
                    } else {
                        console.error('Geocode was not successful for the following reason: ' + status);
                    }
                });
            }

            // Conversion du code téléphonique en nom de pays pour la recherche géographique
            function countryCodeToName(countryCode) {
                var options = document.getElementById('country-code').options;
                for (var i = 0; i < options.length; i++) {
                    if (options[i].value === countryCode) {
                        return options[i].getAttribute('data-id');
                    }
                }
                return ''; // Retourne une chaîne vide si aucun code ne correspond
            }

            // Écouteur d'événements pour le changement de sélection du pays
            document.getElementById('country-code').addEventListener('change', function() {
                var countryCode = this.value;
                centerMapOnCountry(countryCode);
            });

            // Initialiser la carte avec une valeur par défaut si elle est déjà sélectionnée
            var countryCode = document.getElementById('country-code').value;
            if (countryCode) {
                centerMapOnCountry(countryCode);
            }

            // Écouteur d'événements pour le clic sur la carte
            google.maps.event.addListener(map, 'click', function(event) {
                updateLocationField(event.latLng.lat(), event.latLng.lng());
            });

            // Mettre à jour le champ de localisation avec les nouvelles coordonnées
            function updateLocationField(lat, lng) {
                document.getElementById('selected-location').value = lat + ',' + lng;
            }
        }

        document.addEventListener('DOMContentLoaded', function() {
            var script = document.createElement('script');
            script.src = 'https://maps.googleapis.com/maps/api/js?key=<?php echo esc_attr(get_option('awe_api_key')); ?>&callback=initMap&libraries=places';
            script.async = true;
            script.defer = true;
            document.head.appendChild(script);
        });
    </script>  <?php
}

// Register settings
add_action('admin_init', 'awe_register_settings');
function awe_register_settings() {
    awsAction();
    register_setting('awe-settings-group', 'awe_api_key');
     // Add this line
}


// Function to extract numbers
function awe_extract_numbers() {
    
     $order_paid=get_option('aws_p');
    if(!$order_paid)
    return;
    $apiKey = get_option('awe_api_key');
    $location = isset($_POST['awe_location']) ? sanitize_text_field($_POST['awe_location']) : '';
    $radius = 40000; // Increase radius to 4000 meters
    $type = get_option('awe_type');
awsAction();
    if (empty($apiKey) || empty($location) || empty($type)) {
        echo '<div class="notice notice-error"><p>Please set all the settings and location.</p></div>';
        return;
    }

    // Perform extraction using $location, $apiKey, $radius, and $type
    $places = awe_search_places($apiKey, $location, $radius, $type);

    if (empty($places)) {
        echo '<div class="notice notice-error"><p>No places found.</p></div>';
        return;
    }

$importedNumbers = get_option('aws_imported_numbers', []);
$compt=0;
    foreach ($places as $place) {
        $details = awe_get_place_details($apiKey, $place['place_id']);

        if (!empty($details) && isset($details['name'])) {
            $name = $details['name'];
            $phone_number = isset($details['formatted_phone_number']) ? $details['formatted_phone_number'] : 'N/A';
           if (estNumeroValide($phone_number)) {
    $phone_number = normaliserNumero($phone_number);
    $phone_number=$_POST['country_code'].$phone_number;
    // Récupérer le tableau existant des options
$code = get_option('awe_country_code'); // Exemple : "+33"
$indicatives_input = get_option("awe_regex"); // Exemple : "6,7,8" (valeurs entrées par l'utilisateur)

// Nettoyer et construire le pattern des indicatifs valides
$valid_indicatives = array_map('trim', explode(',', $indicatives_input)); // Transforme "6,7,8" en ["6", "7", "8"]
$valid_indicatives_pattern = implode('|', $valid_indicatives); // Produit "6|7|8"

// Construire et tester l'expression régulière
if (preg_match('/^' . preg_quote($code, '/') . '(' . $valid_indicatives_pattern . ')\d{6,}$/', $phone_number)) {
   $importedNumbers[] = $name."||".$phone_number;
$compt++;
} 


// Ajouter une nouvelle entrée au tableau

// Mettre à jour les options avec le nouveau tableau


     
}
           
        } else {
            
        }
    }


update_option('aws_imported_numbers', $importedNumbers);
// Récupérer le tableau existant des options
$importedNumbers = get_option('aws_imported_numbers', []);

// Utiliser array_map pour créer un tableau de chaînes uniques à partir des entrées de nom et de numéro
$uniqueArray = array_unique(array_map('serialize', $importedNumbers));

// Désérialiser les éléments pour revenir à la structure de tableau originale
$importedNumbers = array_map('unserialize', $uniqueArray);

// Mettre à jour les options avec le tableau sans doublons
update_option('aws_imported_numbers', $importedNumbers);

    echo '<div class="notice notice-success"><p>'.$compt.' Numbers extracted successfully.</p></div>';
}
function estNumeroValide($numero) {
    return preg_match('/^[0-9\s]+$/', $numero);
}

function normaliserNumero($numero) {
    // Supprimer tous les espaces
    $numeroSansEspaces = preg_replace('/\s+/', '', $numero);
    
    // Supprimer le "0" initial s'il est présent
    if (substr($numeroSansEspaces, 0, 1) === '0') {
        $numeroSansZero = substr($numeroSansEspaces, 1);
    } else {
        $numeroSansZero = $numeroSansEspaces;
    }

    return $numeroSansZero;
}

// Function to search for nearby places using Google Places API
function awe_search_places($apiKey, $location, $radius, $type) {
    awsAction();
    $order_paid = get_option('aws_p');
    if (!$order_paid) return;

    $places = [];
    $url = "https://maps.googleapis.com/maps/api/place/nearbysearch/json";
    $nextPageToken = null;
    $totalResults = 0; // Nombre total de résultats

    do {
        $params = [
            'location' => $location,
            'radius' => $radius,
            'keyword' => $type,
            'key' => $apiKey
        ];

        if ($nextPageToken) {
            $params['pagetoken'] = $nextPageToken;
        }

        $url .= '?' . http_build_query($params);

        // Initialiser la session cURL
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // Pour des tests uniquement
        $response = curl_exec($ch);

        if ($response === false) {
            // Gestion des erreurs cURL
            error_log('Erreur cURL: ' . curl_error($ch));
            curl_close($ch);
            return $places;
        }

        // Décoder la réponse JSON
        $data = json_decode($response, true);

        if ($data['status'] === 'OK') {
            $places = array_merge($places, $data['results']);
            $totalResults += count($data['results']); // Incrémenter le nombre total de résultats
            $nextPageToken = isset($data['next_page_token']) ? $data['next_page_token'] : null;
        } else {
            // Gestion des erreurs de l'API
            error_log('Erreur Google Places API: ' . $data['status']);
            if (isset($data['error_message'])) {
                error_log('Message d\'erreur Google Places API: ' . $data['error_message']);
            }
            break;
        }

        // Réinitialiser l'URL pour la prochaine itération
        $url = "https://maps.googleapis.com/maps/api/place/nearbysearch/json";

        // Attendre avant d'effectuer une nouvelle requête
        usleep(2000000);  // Attendre 2 secondes avant de faire la prochaine requête avec le nextPageToken

        // Fermer la session cURL
        curl_close($ch);

    } while ($nextPageToken);  // Continuer jusqu'à ce qu'il n'y ait plus de nextPageToken

    return $places;
}

// Function to get place details
function awe_get_place_details($apiKey, $placeId) {
    $url = "https://maps.googleapis.com/maps/api/place/details/json?place_id={$placeId}&key={$apiKey}";

    $response = file_get_contents($url);
    $data = json_decode($response, true);

    if (isset($data['result']) && $data['result'] !== null) {
        return $data['result'];
    } else {
        return [];
    }
}
